# NOTE: Derived from blib/lib/Net/SSLeay.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Net::SSLeay;

#line 1179 "blib/lib/Net/SSLeay.pm (autosplit into blib/lib/auto/Net/SSLeay/ssl_read_until.al)"
### from patch by Clinton Wong <clintdw@netcom.com>

# ssl_read_until($ssl [, $delimit [, $max_length]])
#  if $delimit missing, use $/ if it exists, otherwise use \n
#  read until delimiter reached, up to $max_length chars if defined

sub ssl_read_until ($;$$) {
    my ($ssl,$delim, $max_length) = @_;

    # guess the delim string if missing
    if ( ! defined $delim ) {           
      if ( defined $/ && length $/  ) { $delim = $/ }
      else { $delim = "\n" }      # Note: \n,$/ value depends on the platform
    }
    my $len_delim = length $delim;

    my ($got);
    my $reply = '';
    while (!defined $max_length || length $reply < $max_length) {
        $got = Net::SSLeay::read($ssl,1);  # one by one
        last if print_errs('SSL_read');
	debug_read(\$reply, \$got) if $trace>1;
	last if $got eq '';
        $reply .= $got;
	last if $len_delim
	    && substr($reply, length($reply)-$len_delim) eq $delim;
    }
    return $reply;
}

# end of Net::SSLeay::ssl_read_until
1;
